/* Copyright (C) 2005, 2006, 2007, 2008 by Thomas Hillebrandt and Heiko Will

This file is part of the Micro-mesh SensorWeb Firmware.

Micro-Mesh is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Micro-Mesh is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Micro-Mesh; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

/* As a special exception, if you include this header file into source
   files compiled by GCC, this header file does not by itself cause
   the resulting executable to be covered by the GNU General Public
   License.  This exception does not however invalidate any other
   reasons why the executable file might be covered by the GNU General
   Public License.  */

#include "config.h"
#ifdef INCLUDE_FAT16
#ifndef FILE_H_
#define FILE_H_
#include "type.h"
#include "dir.h"

// Datastructure wich represents an open file
typedef struct {
	uint16_t start_cluster;
	uint16_t akt_cluster;
	uint32_t pos;
	uint16_t cluster_no_in_chain;
	uint32_t size;
	dir_handle dir;
} file_handle;

// closes an open file
void file_closefile(file_handle *file);

// opens a file
int file_openfile(file_handle *file,const char *path,const char mode);

// reads a character out of a file
int file_getchar(file_handle *handle);

// puts a character into a file
int file_putchar(file_handle *handle,const char c);

// seeks a given position in a file
int file_seek(file_handle *handle,unsigned long pos);

int file_write(file_handle *file,uint8_t *buffer,unsigned int size);


#endif /*FILE_H_*/
#endif
