/* Copyright (C) 2005, 2006, 2007, 2008 by Thomas Hillebrandt and Heiko Will

This file is part of the Micro-mesh SensorWeb Firmware.

Micro-Mesh is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Micro-Mesh is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Micro-Mesh; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

/* As a special exception, if you include this header file into source
   files compiled by GCC, this header file does not by itself cause
   the resulting executable to be covered by the GNU General Public
   License.  This exception does not however invalidate any other
   reasons why the executable file might be covered by the GNU General
   Public License.  */

/**
 * Created on Tue Oct 16 23:26:22 CEST 2007
 *
 * Created by     WSN Simulator 0.4.0 - Beta 1
 *
 * using plugin   CC1100Node [version=1.17, date=16.10.2007, author=Thomas Hillebrandt]
 *
 */
#ifndef CC1100_DEFAULTSETTINGS_H
#define CC1100_DEFAULTSETTINGS_H

#define M (1.2)
#define SPI_DELAY (5*M)

// Values dependent on your settings
#define PATABLE (5)
#define SEQ_VALID_TIME (4440*M)

#define WOR_TIMEOUT (2*M)
#define WOR_MAN_SLEEP_TIME (4428*M)
#define WOR_MAN_RX_TIME (36*M)
#define WOR_RX_TIME (0x04)
#define BURST_COUNT (146)

#define WORCTRL (0x78)
#define WOREVT0 (0x65)
#define WOREVT1 (0x49)

// Constant values (only data rate dependent)
#define DIFS (50*M + SPI_DELAY)
#define TIMEOUT_SEND (15*M)
#define SLOTTIME (10*M)
#define SEND_TIME (30*M)

extern const unsigned char conf[39];

#endif
