/* Copyright (C) 2005, 2006, 2007, 2008 by Thomas Hillebrandt and Heiko Will

This file is part of the Micro-mesh SensorWeb Firmware.

Micro-Mesh is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Micro-Mesh is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Micro-Mesh; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include "driver_system.h"
#include "driver_controller.h"
#include "board.h"
#include "type.h"

unsigned int getADCSample(void)
{
	unsigned int tmp;
	TurOnPeripheral(PCAD1);
	PINSEL0 |= BIT21+BIT20; // Select ADC
	AD1CR = BIT2 + BIT12+BIT13+BIT14+ BIT21+ BIT24; // PORT 0.10 , 14 CLkDivider, ADC=on

	while (!((tmp=AD1DR2) & BIT31)) ;	// Wait for conversion done
	
	AD1CR=0; // Turn off aDC
	PINSEL0 &= ~(BIT21+BIT20); //Select GPIO (ADC off)
	TurOffPeripheral(PCAD1);
	
	tmp<<=16;
	tmp>>=22;
	return tmp;
}

