/* Copyright (C) 2005, 2006, 2007, 2008 by Thomas Hillebrandt and Heiko Will

This file is part of the Micro-mesh SensorWeb Firmware.

Micro-Mesh is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Micro-Mesh is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Micro-Mesh; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include "pa.h"
#include "type.h"
#include "driver_controller.h"
#include "driver_timer.h"

void PaOn(unsigned int power)
{
	PINSEL1|=BIT19;		//DA an
	FIO1SET=BIT27;		//LNA aus
	DACR=power<<6;		//Output is 3,3v / 1024 * DACR
	FIO1SET=BIT25; 		//TX Mode an
	FIO1CLR=BIT26; 		//RX Mode aus
	FIO1SET=BIT31; 		//PA einschalten
	_wait(6);
}

void PaOff(void)
{
	FIO1CLR=BIT25; 		//TX Mode aus
	FIO1SET=BIT26;		//RX Mode an
	FIO1CLR=BIT31; 		//PA ausschalten
	PINSEL1&=~BIT19; 	//DA aus
}

void LnaOn(void)
{	
	FIO1CLR=BIT27;		//LNA an
}

void LnaOff(void)
{
	FIO1SET=BIT27;		//LNA aus
}
