#include <stdio.h>
#include "hardware.h"
#include "driver_uart1.h"
#include "console.h"
#include "driver_system.h"
#include "driver_sht11.h"
 
s_devices* std_devices;

	static driver_serial dev_serial1;
	static driver_chardevice dev_console;
    static s_devices sd;
    
    /* Sensors */
    static sensor sht11_temp;
    static sensor sht11_humi;
    
void configure_dev()
{
	std_devices=&sd;
	
	console_new(&dev_console, &dev_serial1);
	uart1_new((void*) &dev_console,console_char_in, &dev_serial1);

	std_devices->stdio_device = &dev_console;
	dev_serial1.driver.base.init(&(dev_serial1.driver));

	sht11_temp_new(&sht11_temp);
	sht11_humi_new(&sht11_humi);
	
	static sensor* sens[] = {NULL,&sht11_temp,&sht11_humi,NULL};
	std_devices->sensors = sens;
	
}
