/* Copyright (C) 2005, 2006, 2007, 2008 by Thomas Hillebrandt and Heiko Will

This file is part of the Micro-mesh SensorWeb Firmware.

Micro-Mesh is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Micro-Mesh is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Micro-Mesh; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

/* As a special exception, if you include this header file into source
   files compiled by GCC, this header file does not by itself cause
   the resulting executable to be covered by the GNU General Public
   License.  This exception does not however invalidate any other
   reasons why the executable file might be covered by the GNU General
   Public License.  */

#ifndef SPI0_H_
#define SPI0_H_

#include "std_defines.h"
#include "type.h"

#define SPI_INIT \
	st( \
		UCTL0  = SWRST; \
		UCTL0 |= CHAR + SYNC + MM; \
		UTCTL0 = CKPH + SSEL1 + SSEL0 + STC; \
		UBR00 = 0x02; \
		UBR10 = 0x00; \
		UMCTL0 = 0x00; \
		URCTL0 = 0x00; \
		ME1 |= USPIE0; \
		UCTL0  &= ~SWRST; \
	)

//----------------------------------------------------------------------------------
//  void spiInit(uint8_t clockrate)
//
//  DESCRIPTION:
//		Init UART0 for SPI mode.
//
//  ARGUMENTS:
//      uint8_t clockrate
//			Ignore clockrate parameter (no effect for now).
//
//----------------------------------------------------------------------------------
void spi0_init(uint8_t clockrate);

#endif /*SPI0_H_*/
