/* Copyright (C) 2005, 2006, 2007, 2008 by Thomas Hillebrandt and Heiko Will

This file is part of the Micro-mesh SensorWeb Firmware.

Micro-Mesh is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Micro-Mesh is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Micro-Mesh; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include "user_apps.h"
#include "type.h"
#include "driver_sht11.h"
#include "smallib.h"
#include "routing.h"
#include "user_pakethandlers.h"
#include "net.h"
#include "usertimer.h"
#include "driver_system.h"
#include "config.h"
#include "rulesystem.h"
#include "funk.h"
#include "timer.h"

void rule_delete(void* none){
	rule_protocoll_t *rp;
	rp->command = RULE_DELRULE;
	rp->rule_id = 0;
	net_send(150, 1, (uint8_t*) &rp);
}

void rule_sender(void* none){
	rule_protocoll_t *rule;
	char r[] = {0,0,0,0,9, 0, 0, 0, 1, 0, 0, 0x00, 0x02,0x00, 35, 00, 0x00, 0x00, 0x02,0x01, 43, 0, 0x00, 0x00, 0x02,0x01, 0, 0, 0x00, 0x00, 0x02,0x02, 1, 0, 0x00, 0x00, 0x02,0x00, 51, 51, 6, 66, 0x01, 0x01, 0x03, 0x00};
	rule = (rule_protocoll_t*) r;
	rule->rule.check_period = 1;
	rule->rule.if_b.func = 1;
	rule->rule.if_b.value.valtype = 1;
	rule->rule.if_b.value.value_t.fval = 25.0;
	rule->command = RULE_ADDRULE;
	rule->seqno = 1;
	net_send(150, 1, r);
	sl_printf("rule sent! size: %u \n", sizeof(rule_t));
	//registerUserTimer(rule_delete,30,NULL);
}


void demoApplication(void *none){
	uint8_t buffer[52];
	int pos=0;
	uint16_t type;
	if (uid == 1) return;
#ifdef INCLUDE_SHT11
	// Copy Humidity
	sht11_update_data();
	buffer[pos] = STYPE_UINT16;
	pos+=1;
	int val= (int) sht11_data.humi_val.f;
	sl_memcpy(buffer+pos,&val,sizeof(uint16_t));
	pos+=sizeof(uint16_t);
	type=2;
	sl_memcpy(buffer+pos,&type,sizeof(uint16_t));
	pos+=sizeof(uint16_t);
	
	// Copy Temperature
	buffer[pos] = STYPE_FLOAT;
	pos+=1;
	float v= sht11_data.temp_val.f;
	sl_memcpy(buffer+pos,&v,sizeof(float));
	pos+=sizeof(float);
	type=1;
	sl_memcpy(buffer+pos,&type,sizeof(uint16_t));
	pos+=sizeof(uint16_t);
	buffer[pos]=0;
#endif
#ifdef INCLUDE_BATTERY
	// Copy Battery Volatage
	buffer[pos] = STYPE_FLOAT;
	pos+=1;
	float v= ReadBatteryVoltage();
	sl_memcpy(buffer+pos,&v,sizeof(float));
	pos+=sizeof(float);
	type=3;
	sl_memcpy(buffer+pos,&type,sizeof(uint16_t));
	pos+=sizeof(uint16_t);
	buffer[pos]=0;
#endif
	net_send(131, 1, buffer);
	Led1Toggle();
}
