package carrera.data;

import carrera.Main;
import carrera.serial.SerialConnectionDataEvent;
import carrera.serial.SerialConnectionDataListener;
import carrera.serial.SerialConnectionDefaults;

/**
 *
 * @author hillebra
 */
public class PlotDataListener implements SerialConnectionDataListener {

    private Main main;
    
    /** Die ID der seriellen Verbindung */
    private int connectionID = -1;
    
    public PlotDataListener(Main main) {
        this.main = main;
    }
    
    public SerialConnectionDefaults getSerialConnectionDefaults() {
        return new SerialConnectionDefaults(115200, 8, 0, 0);
    }

    public int getSerialConnectionID() {
        return connectionID;
    }

    public void serialConnectionEstablished(int connectionID) {
        this.connectionID = connectionID;
    }

    public void serialConnectionClosing() {}
    
    public void serialConnectionClosed() {
        this.connectionID = -1;
    }

    public void serialConnectionDataEvent(SerialConnectionDataEvent event) {
        main.parseAndAddXYData(event.getData());
    }

}
