package carrera.data.plot;

import java.util.Random;

/** Test driver for the plot system */
public class PlotDriver extends Thread {

    private PlotData plotData;
    private Random rand = new Random();
    private boolean stop = false;

    
    private int acc_x, acc_y, acc_z;
    private int acc_x_t, acc_y_t, acc_z_t;
    private int acc_x_step, acc_y_step, acc_z_step;
    private int acc_c_x, acc_c_y, acc_c_z;
    
    private static final int STEP_TIME = 10;
    
    public PlotDriver(PlotData plotData) {
        this.plotData = plotData;
    }
    
    public void finish() {
        stop = true;
    }

    public void run() {
        while (!stop) {
            
            if (acc_x_t <= 0 || acc_c_x == acc_x) {
                if (rand.nextDouble() > 0.8) {
                    acc_x = rand.nextInt(2000) - 1000;
                } else {
                    acc_x = 0;
                }
                acc_x_t = 500 + rand.nextInt(1000);
                acc_x_step = Math.abs(acc_x - acc_c_x) / 6 + 1;
            }
            
            acc_c_x = acc_x < 0 ? acc_c_x - rand.nextInt(acc_x_step) : acc_c_x + rand.nextInt(acc_x_step);
            acc_c_x = acc_x < 0 ? acc_c_x < acc_x ? acc_x : acc_c_x : acc_c_x > acc_x ? acc_x : acc_c_x;
            acc_x_t -= STEP_TIME;
            
            if (acc_y_t <= 0 || acc_c_y == acc_y) {
                if (rand.nextDouble() > 0.8) {
                    acc_y = rand.nextInt(2000) - 1000;
                } else {
                    acc_y = 0;
                }
                acc_y_t = 500 + rand.nextInt(1000);
                acc_y_step = Math.abs(acc_y - acc_c_y) / 6 + 1;
            }
            
            acc_c_y = acc_y < 0 ? acc_c_y - rand.nextInt(acc_y_step) : acc_c_y + rand.nextInt(acc_y_step);
            acc_c_y = acc_y < 0 ? acc_c_y < acc_y ? acc_y : acc_c_y : acc_c_y > acc_y ? acc_y : acc_c_y;
            acc_y_t -= STEP_TIME;
            
            if (acc_z_t <= 0 || acc_c_z == acc_z) {
                if (rand.nextDouble() > 0.8) {
                    acc_z = rand.nextInt(2000) - 1000;
                } else {
                    acc_z = 0;
                }
                acc_z_t = 500 + rand.nextInt(1000);
                acc_z_step = Math.abs(acc_z - acc_c_z) / 6 + 1;
            }
            
            acc_c_z = acc_z < 0 ? acc_c_z - rand.nextInt(acc_z_step) : acc_c_z + rand.nextInt(acc_z_step);
            acc_c_z = acc_z < 0 ? acc_c_z < acc_z ? acc_z : acc_c_z : acc_c_z > acc_z ? acc_z : acc_c_z;
            acc_z_t -= STEP_TIME;
            
            plotData.addAccData(rand.nextInt(2000) - 1000,
                    rand.nextInt(2000) - 1000, rand.nextInt(2000) - 1000,
                    acc_c_x, acc_c_y, acc_c_z);
            
            plotData.addGyroData(rand.nextInt(2000) - 1000,
                    rand.nextInt(2000) - 1000, rand.nextInt(2000) - 1000,
                    acc_c_x, acc_c_y, acc_c_z);
            
            /** 100 x per second */
            try {
                Thread.sleep(STEP_TIME);
            } catch (InterruptedException e) {
            }
        }
    }
    
}
