package carrera.dialog;

import carrera.Main;
import carrera.MainView;
import carrera.data.CarreraPlayer;

/**
 *
 * @author  hillebra
 */
public class NewGameDialog extends javax.swing.JDialog {

    private Main main;
    
    /** Creates new form NewGameDialog */
    public NewGameDialog(java.awt.Frame parent, boolean modal, Main main) {
        super(parent, modal);
        this.main = main;
        initComponents();
        getRootPane().setDefaultButton(bOk);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnGrp = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        bOk = new javax.swing.JButton();
        bCancel = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        lName = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        tfName = new javax.swing.JTextField();
        jPanel5 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        tfName2 = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Neues Spiel");
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        bOk.setText("OK");
        bOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bOkActionPerformed(evt);
            }
        });
        jPanel1.add(bOk);

        bCancel.setText("Abbrechen");
        bCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bCancelActionPerformed(evt);
            }
        });
        jPanel1.add(bCancel);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel6.setLayout(new java.awt.BorderLayout());

        lName.setText("Spieler 1:");
        lName.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
        lName.setBorder(javax.swing.BorderFactory.createEmptyBorder(2, 2, 2, 1));
        jPanel6.add(lName, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel6);

        jPanel3.setLayout(new java.awt.BorderLayout());

        tfName.setText(Main.lastUserName);
        jPanel3.add(tfName, java.awt.BorderLayout.SOUTH);

        jPanel2.add(jPanel3);

        jPanel5.setBorder(javax.swing.BorderFactory.createEmptyBorder(2, 2, 2, 1));
        jPanel5.setLayout(new java.awt.BorderLayout());

        jLabel1.setText("Spieler 2:");
        jLabel1.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
        jPanel5.add(jLabel1, java.awt.BorderLayout.PAGE_START);

        jPanel2.add(jPanel5);

        jPanel4.setLayout(new java.awt.BorderLayout());

        tfName2.setText(CarreraPlayer.AUTO_DEFAULT_NAME);
        jPanel4.add(tfName2, java.awt.BorderLayout.SOUTH);

        jPanel2.add(jPanel4);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-396)/2, (screenSize.height-172)/2, 396, 172);
    }// </editor-fold>//GEN-END:initComponents

private void bCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bCancelActionPerformed
    dispose();
}//GEN-LAST:event_bCancelActionPerformed

private void bOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bOkActionPerformed
    String s1 = tfName.getText().trim();
    String s2 = tfName2.getText().trim();
    
    if (s1.equals("")) {
        ((MainView)getParent()).showErrorMessage("Fehler", "Bitte Spielernamen angeben!");
        return;
    }
    
    if (s1.length() > CarreraPlayer.MAX_NAME_LENGTH) {
        ((MainView)getParent()).showErrorMessage("Fehler",
                "Spielername zu lang, maximal " + CarreraPlayer.MAX_NAME_LENGTH + " Zeichen!");
        return;
    }
    
    if (s2.equals("")) {
        ((MainView)getParent()).showErrorMessage("Fehler", "Bitte Spielernamen 2 angeben!");
        return;
    }
    
    if (s2.length() > CarreraPlayer.MAX_NAME_LENGTH) {
        ((MainView)getParent()).showErrorMessage("Fehler",
                "Spielername 2 zu lang, maximal " + CarreraPlayer.MAX_NAME_LENGTH + " Zeichen!");
        return;
    }
    
    main.initNewGame(s1, s2);
    dispose();
}//GEN-LAST:event_bOkActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bCancel;
    private javax.swing.JButton bOk;
    private javax.swing.ButtonGroup btnGrp;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JLabel lName;
    private javax.swing.JTextField tfName;
    private javax.swing.JTextField tfName2;
    // End of variables declaration//GEN-END:variables

}
