package carrera.serial;

import java.util.EventObject;

/**
 * Ereignis-Objekt f�r die serielle Schnittstelle.
 * 
 * @version 1.0, 2008-01-14
 * @author  Thomas Hillebrandt
 * @since   1.0
 */
public class SerialConnectionEvent extends EventObject {

    private int type;
    
    public static final int SERIAL_CONNECTION_CREATE_REQUEST = 1;
    
    /**
     * Erzeugt ein neues <code>SerialConnectionEvent</code>-Objekt.
     *
     * @param source Das Ereignis ausl�sende Objekt.
     * @param type Der Ereignistyp.
     */
    public SerialConnectionEvent(Object source, int type) {
        super(source);
        this.type = type;
    }
    
    public int getType() {
        return type;
    }

}
